#include <stdio.h>
#include <stdlib.h>

#include "inputspec.h"
#include "piece.h"

extern InputSpec Spec;

/* Fill in the input specifications by reading the specification from standard in. */

void ReadSpec()
{
int width, height;
int i, j, n;

	/* read input spec */
	
	scanf("%d%d", &Spec.boxWidth, &Spec.boxHeight);

	for (j = 0; j < MAXBOXDIM; ++j)
		for (i = 0; i < MAXBOXDIM; ++i)
			if (j < Spec. boxHeight && i < Spec.boxWidth)
				scanf("%d", &Spec.boxShape[i][j]);
			else
				Spec.boxShape[i][j] = 1;

	scanf(" - ");

	scanf("%d", &Spec.numShapes);

	Spec.goalIndex = Spec.numShapes;
	++Spec.numShapes;					/* for the goal piece shape	*/
	
	Spec.shapes = (PieceShape *) malloc(sizeof(PieceShape) * Spec.numShapes);	/* allocate space for the piece shapes */
	
	/* read the piece shapes */
		
	for (n = 0; n < Spec.numShapes - 1; ++n)
	{
		scanf("%d%d", &width, &height);
		
		for (j = 0; j < MAXPIECEDIM; ++j)
			for (i = 0; i < MAXPIECEDIM; ++i)
				if (j < height && i < width)
					scanf("%d", &Spec.shapes[n][i][j]);
				else
					Spec.shapes[n][i][j] = 0;
	}
		
	scanf(" - ");
	
	/* read the goal piece shape */
	
	scanf("%d%d", &width, &height);
	
	for (j = 0; j < MAXPIECEDIM; ++j)
		for (i = 0; i < MAXPIECEDIM; ++i)
			if (j < height && i < width)
				scanf("%d", &Spec.shapes[Spec.goalIndex][i][j]);
			else
				Spec.shapes[Spec.goalIndex][i][j] = 0;
		
	scanf(" - ");
	
	/* read the goal location */
	
	scanf("%d%d", &Spec.goalX, &Spec.goalY);
}
