#include "piece.h"


#define MAXBOXDIM	12


/* BoxShape is the 2-d bit-vector defining the shape of the box that holds the
   pieces.  If BoxShape[x][y] is true, then the square (x, y) is occupied by
   part of the box, and cannot hold a piece.  If it's false, then the square
   (x, y) is empty, and can hold (part of) a piece. 
*/

typedef struct InputSpec
{
	PieceShape 	*shapes;					/* the table of valid piece shapes */
	int			numShapes;					/* how many shapes there are, including the goal shape */
	int			goalIndex;					/* the last shape index (numShapes - 1) */
	int 		goalX, goalY;				/* goal location */

	int			boxShape[MAXBOXDIM][MAXBOXDIM];
	int 		boxWidth, boxHeight;
} InputSpec;


void ReadSpec();
